Bug 868005 - install_initd/remove_initd does not work in a systemd world
install_initd/remove_initd does not work in a systemd world
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: chkconfig (Show other bugs)
18
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Lukáš Nykrýn
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-10-18 16:41 EDT by Bill Nottingham
Modified: 2014-03-16 23:32 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-02-05 17:50:32 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
chkconfig patch (7.96 KB, patch)
2013-02-08 10:53 EST, Lukáš Nykrýn
no flags Details | Diff

  None (edit)
Description Bill Nottingham 2012-10-18 16:41:51 EDT
Description of problem:

chkconfig's LSB dependency support consists of reordering the Sxx/Kxx links due to specified LSB dependencies at 'chkconfig --add' time. In a systemd world, this is more or less irrelevant - systemd itself will do the ordering at runtime. (We could rip this code out and simplify a lot of things...)

However, there is one area where there is a problem. By the spec definition, install_initd/remove_initd must check dependencies at install/remove time, and *fail* the operation if there are dependency errors. In a SysV world, this worked OK, because chkconfig knew about the state of everything. However, now that assorted services that LSB sysv scripts might depend on have moved to systemd, this won't work - chkconfig doesn't know what the LSB state is.

When called as install_initd/remove_initd chkconfig must scan for all configured systemd services and use their enabled status to determine this.

Potential solutions:
1) trawl the filesystem ourselves in chkconfig
2) screenscrape systemctl
3) build install_initd/remove_initd as part of systemd itself, using *its* code directly to do this work

Version-Release number of selected component (if applicable):

any

How reproducible:

100%
Comment 1 Lukáš Nykrýn 2012-11-01 09:22:49 EDT
I will probably go with second option. But first we should implement this RFE to systemd #795365.
Comment 2 Lukáš Nykrýn 2013-02-08 10:53:38 EST
Created attachment 695137 [details]
chkconfig patch

With this patch chkconfig will ask for information about systemd services through systemctl show and then will try to convert target dependencies to runlevel logic. This method has some drawbacks, this will not work in pure chroot because systemctl show requires dbus and I am also not sure how to process lsb dependencies like $syslog, $time,... In some cases these can be rewritten as *.target but not all of them.
Comment 3 Fedora End Of Life 2013-12-21 10:09:14 EST
This message is a reminder that Fedora 18 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 18. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '18'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 18's end of life.

Thank you for reporting this issue and we are sorry that we may not be 
able to fix it before Fedora 18 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior to Fedora 18's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 4 Fedora End Of Life 2014-02-05 17:50:32 EST
Fedora 18 changed to end-of-life (EOL) status on 2014-01-14. Fedora 18 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.